export declare enum ImageFormat {
    Srgbx8 = 0,
    Srgba8StraightAlpha = 1,
    RgbaF32PremulAlpha = 2,
}
export declare type ImageLike = HTMLImageElement | HTMLCanvasElement | HTMLVideoElement;
export declare function coerceImageToSrgba8StraightAlpha(image: Uint8Array | ImageLike, width?: number, height?: number): Uint8Array;
export declare function coerceToRgbaF32PremulAlphaFrom(image: Uint8Array | Float32Array | ImageLike, format: ImageFormat, width?: number, height?: number): Float32Array;
export declare function coerceRgbaF32PremulAlphaTo(image: Float32Array, format: ImageFormat): Uint8Array | Float32Array;
export declare const SRGB_DECODE_TABLE: Float32Array;
export declare const SRGB_ENCODE_TABLE: Uint8Array;
export declare function resampleRgbF32(inImage: Float32Array, inWidth: number, inHeight: number, outWidth: number, outHeight: number): Float32Array;
