"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
/*
 * Copyright (c) 2017 yvt
 *
 * This file is a part of hyper3d-envmapgen. Please read the license text that
 * comes with the source code for use conditions.
 */
var image_1 = require("./image");
var globalModule = null;
var globalModulePromise = null;
/**
 * Retrieves the built-in core WebAssembly binary module. Can be used to
 * customize the initialization behavior.
 */
function getCoreWasmBlob() {
    return require('./wasm-blob');
}
exports.getCoreWasmBlob = getCoreWasmBlob;
/**
 * Retrieves the compiled global WebAssembly module. Triggers a synchronous
 * compilation on first use.
 */
function getGlobalCoreModule() {
    if (!globalModule) {
        globalModule = new WebAssembly.Module(getCoreWasmBlob());
    }
    return globalModule;
}
exports.getGlobalCoreModule = getGlobalCoreModule;
/**
 * Retrieves the compiled global WebAssembly module.
 */
function getGlobalCoreModulePromise() {
    if (!globalModulePromise) {
        globalModulePromise = WebAssembly.compile(getCoreWasmBlob());
    }
    return globalModulePromise;
}
exports.getGlobalCoreModulePromise = getGlobalCoreModulePromise;
/**
 * Provides a JavaScript interface to the core services.
 */
var CoreInstance = /** @class */ (function () {
    /**
     * Synchronous constructor of `CoreInstance`. `options.module` and
     * `options.instance` must not be `null` or `undefined` if this
     * constructor is called from the main thread.
     */
    function CoreInstance(options) {
        if (options === void 0) { options = {}; }
        this.module = options.module || getGlobalCoreModule();
        this.instance = options.instance || new WebAssembly.Instance(this.module);
        var emg = this.instance.exports;
        emg.emg_init();
    }
    /**
     * Asynchronous constructor of `CoreInstance`.
     */
    CoreInstance.create = function (options) {
        if (options === void 0) { options = {}; }
        return __awaiter(this, void 0, void 0, function () {
            var module, _a, instance, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        _a = options.module;
                        if (_a) return [3 /*break*/, 2];
                        return [4 /*yield*/, getGlobalCoreModulePromise()];
                    case 1:
                        _a = (_c.sent());
                        _c.label = 2;
                    case 2:
                        module = _a;
                        _b = options.instance;
                        if (_b) return [3 /*break*/, 4];
                        return [4 /*yield*/, WebAssembly.instantiate(module)];
                    case 3:
                        _b = (_c.sent());
                        _c.label = 4;
                    case 4:
                        instance = _b;
                        return [2 /*return*/, new CoreInstance(__assign({}, options, { module: module, instance: instance }))];
                }
            });
        });
    };
    /**
     * Applies a linear-time approximate spherical Gaussian blur on a given
     * cube map image.
     *
     * `C` is the number of elements per pixel and fixed at `4` in the current
     * version.
     *
     * @param inFaces The input cube map image. Must have at least 6 elements
     *                and each one must be at least `(size ** 2) * C` long.
     * @param outFaces The output cube map image. Must have at least 6 elements
     *                 and each one must be at least `(size ** 2) * C` long.
     *                 You can specfify the same value as `inFaces` for in-place
     *                 operation.
     * @param size The length of each side of the cube map, in pixels.
     * @param format The image format. Must be `RgbaF32PremulAlpha`.
     * @param kernel The convolution kernel. Must be odd-sized.
     * @param kernelScale The spatial scale of the kernel. See `ltasgblur.rs` for
     *                    more info.
     * @param numPasses Specifies how many times a Gaussian blur is applied on
     *                  the image. It is more efficient to use this parameter
     *                  than calling this function for multiple times.
     */
    CoreInstance.prototype.ltasg = function (inFaces, outFaces, size, format, kernel, kernelScale, numPasses) {
        // Fail-fast
        if (inFaces.length < 6) {
            throw new Error("inFaces.length ≥ 6");
        }
        if (outFaces.length < 6) {
            throw new Error("outFaces.length must be ≥ 6");
        }
        size |= 0; // coerce to integer
        numPasses |= 0; // coerce to integer
        var pixels = size * size;
        var channels = 4;
        var elements = pixels * channels;
        for (var i = 0; i < 6; ++i) {
            if (inFaces[i].length < elements) {
                throw new Error("∀i∈ℕ.(0 ≤ i < 6 ⇒ inFaces[i].length ≥ elements)");
            }
            if (outFaces[i].length < elements) {
                throw new Error("∀i∈ℕ.(0 ≤ i < 6 ⇒ outFaces[i].length ≥ elements)");
            }
        }
        if (format != image_1.ImageFormat.RgbaF32PremulAlpha) {
            throw new Error("format must be RgbaF32PremulAlpha");
        }
        if ((kernel.length & 1) === 0) {
            throw new Error("kernel must be odd-sized");
        }
        if (!(kernelScale > 0)) {
            throw new Error("kernelScale must be a positive number");
        }
        var kernelRadius = kernel.length >> 1;
        if (!(size > kernelRadius * kernelScale * 1.8 /* ≈ √3 */)) {
            throw new Error("kernel is too large compared to the image size");
        }
        if (size > 32768) {
            throw new Error("The image is too large");
        }
        if (numPasses < 0) {
            throw new Error("numPasses must be a positive number");
        }
        // Allocate buffers
        //  - `elements * sizeof::<f32>() * 6 * 2` bytes for input/output passing
        //    and temporary (ping-pong buffer)
        //  - `kernel.length * sizeof::<f32>()` for kernel
        var emg = this.instance.exports;
        var bufferLen = elements * 48 + kernel.length * 4;
        var pBuffer = emg.emg_malloc(bufferLen);
        {
            // Increase the memory allocation if needed
            var extra = ((pBuffer + bufferLen + 0xffff) >> 16) - emg.memory.buffer.byteLength;
            if (extra > 0) {
                emg.memory.grow(extra);
            }
        }
        var pImages1 = pBuffer;
        var pImages2 = pBuffer + elements * 4 * 6;
        var pKernel = pImages2 + elements * 4 * 6;
        // Upload the inputs
        for (var i = 0; i < 6; ++i) {
            new Float32Array(emg.memory.buffer, pImages1 + i * (elements * 4))
                .set(inFaces[i]);
        }
        new Float32Array(emg.memory.buffer, pKernel).set(kernel);
        // Let's get this show on the road 🍎
        for (var i = 0; i < numPasses; ++i) {
            for (var k = 0; k < 3; ++k) {
                // `pImages1` → `pImages2`
                emg.emg_ltasg_single(pImages2, pImages1, size, pKernel, kernel.length, kernelScale, k);
                // Swap buffers
                var t = pImages1;
                pImages1 = pImages2;
                pImages2 = t;
            }
        }
        // Retrieve the outputs
        for (var i = 0; i < 6; ++i) {
            outFaces[i].set(new Float32Array(emg.memory.buffer, pImages1 + i * (elements * 4), elements));
        }
        emg.emg_free(pBuffer);
    };
    return CoreInstance;
}());
exports.CoreInstance = CoreInstance;
//# sourceMappingURL=wasm.js.map